<script setup lang="ts">
const props = defineProps<{ gene: string }>();
const { fetchByGenes } = useGOAnnotationService();
const { data, error, pending } = await useAsyncData(
  `goannotations-${props.gene}`,
  () => fetchByGenes([props.gene]),
);
const repository = useGOAnnotationRepository(props.gene, data.value || []);
</script>

<template>
  <AsyncView
    :error="error"
    :loading="pending"
    :error-message="`Failed to fetch GO annotations for gene ${props.gene}`"
    loading-type="article"
  >
    <CRUDView
      :repository="repository"
      form-label="Propose a GO term"
      submit-label="Submit and close"
      reuse-label="Submit and reuse for another GO term"
    >
      <template #item="{ item }">
        <GOAnnotationItem :annotation="item" />
      </template>

      <template #inputs="{ item, update }">
        <GOAnnotationInput :annotation="item" @update:annotation="update" />
      </template>
    </CRUDView>
  </AsyncView>
</template>
